
import processing.serial.*;  //1***********

Serial port;        //2***********
float theta, val;   //3***********

void setup() {
  size(512, 380);
  String arduinoPort = Serial.list()[5];     //4***********
  port = new Serial(this, arduinoPort, 9600);//5***********
}

void draw() {
  background(0,55,255);
  frameRate(30);
  stroke(0,255,0);
  strokeWeight(3);

  if ( port.available() > 0) {           //6***********
    val = port.read();                   //7***********
    val = map(val, 0, 255, 0, width);    //8***********  
  }                                      //9***********
  float a = (val / (float) width) * 90f; //10  ***********
  theta = radians(a);
  translate(width/2,height);
  line(0,0,0,-120);
  translate(0,-120);
  branch(120);
}

void branch(float h) {
  h *= 0.68;
  if (h > 2) {
    pushMatrix(); 
    rotate(theta); 
    line(0, 0, 0, -h);  
    translate(0, -h); 
    branch(h);    
    popMatrix();  
    
    pushMatrix();
    rotate(-theta);
    line(0, 0, 0, -h);
    translate(0, -h);
    branch(h);
    popMatrix();
  }
}

